mysite/enquetes/urls.py
from django.urls import path
from . import views

app_name = "enquetes"
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('<int:pk>/', views.DetalhesView.as_view(), name='detalhes'),
    path('<int:pk>/votacao/', views.VotacaoView.as_view(), name='votacao'),
    path('<int:pk>/resultado/', views.ResultadoView.as_view(), name='resultado'),
    path('nova_enquete/', views.NovaEnqueteView.as_view(), name='nova_enquete'),
    path('encerradas/', views.EncerradasView.as_view(), name='encerradas'),
    path('autor/<int:pk>/', views.AutorView.as_view(), name='autor'),
    path('autor/<int:pk>/editar/', views.PerfilView.as_view(), name='editar_perfil'),
    path('rotulo/<int:pk>/', views.RotuloView.as_view(), name='rotulo'),
    path('busca/', views.BuscaView.as_view(), name='busca'),
    path('cadastro/', views.NovoAutorView.as_view(), name='novo_autor'),
]

mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('root.urls')),
    path('enquetes/', include('enquetes.urls')),
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
]

mysite/root/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.index, name="root"),
]

mysite/enquetes/models.py
import datetime
from django.db import models
from django.forms import ModelForm, CheckboxSelectMultiple, Textarea
from django.forms import SelectDateWidget, inlineformset_factory
from django.conf import settings
from django.utils import timezone


class Rotulo(models.Model):
    titulo = models.CharField(max_length=20)
    class Meta:
        verbose_name_plural = 'Rótulos'
    def __str__(self):
        return self.titulo

class Autor(models.Model):
    nome = models.CharField(max_length=80)
    genero = models.CharField(max_length=100)
    descricao = models.TextField()
    usuario = models.OneToOneField(
        settings.AUTH_USER_MODEL,
        on_delete=models.CASCADE,
        null = True
    )
    class Meta:
        verbose_name_plural = 'Autores'
    def __str__(self):
        return self.nome

class Pergunta(models.Model):
    texto = models.CharField(max_length=200, unique=True)
    data_publicacao = models.DateTimeField('Data de publicação')
    data_encerramento = models.DateField('Encerramento', null=True)
    imagem = models.ImageField(upload_to='enquetes', null=True, blank=True)
    rotulos = models.ManyToManyField(Rotulo, verbose_name='Rótulos')
    autor = models.ForeignKey(Autor, on_delete=models.CASCADE, null=True)
    def __str__(self):
        return self.texto
    def publicada_recentemente(self):
        agora = timezone.now()
        return agora-datetime.timedelta(days=1) <= self.data_publicacao <= agora
    publicada_recentemente.admin_order_field = 'data_publicacao'
    publicada_recentemente.boolean = True
    publicada_recentemente.short_description = 'É recente?'
    def total_de_votos(self):
        total = 0
        for op in self.opcao_set.all():
            total += op.votos
        return total

class PerguntaForm(ModelForm):
    class Meta:
        model = Pergunta
        fields = [
            'texto', 'imagem', 'rotulos', 'data_encerramento'
        ]
        labels = {
            'texto': 'Enunciado da enquete',
            'data_encerramento': 'Data de encerramento',
        }
        widgets = {
            'texto': Textarea(attrs={'cols': 50, 'rows': 2}),
            'rotulos': CheckboxSelectMultiple(),
            'data_encerramento': SelectDateWidget(),
        }

class Opcao(models.Model):
    texto = models.CharField(max_length=100)
    votos = models.IntegerField(default=0)
    pergunta = models.ForeignKey(Pergunta, on_delete=models.CASCADE)
    def __str__(self):
        return self.texto
    class Meta:
        verbose_name_plural = "Opções"
    def porcentagem(self):
        total = self.pergunta.total_de_votos()
        return (self.votos / total)*100

class OpcaoForm(ModelForm):
    class Meta:
        model = Opcao
        fields = ['texto']
        labels = {'texto': 'Texto da opção',}

OpcaoFormset = inlineformset_factory(
    Pergunta, Opcao, form=OpcaoForm, extra=6, can_delete=False
)

mysite/enquetes/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponseRedirect, Http404
from django.utils.decorators import method_decorator
from django.urls import reverse
from django.utils import timezone
from django.views import generic
from .models import Pergunta, Opcao, Autor, Rotulo, PerguntaForm, OpcaoFormset
from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import User
from django.contrib.auth import login
from django.contrib import messages

class IndexView(generic.View):
    def get(self, request, *args, **kwargs):
        enquetes = Pergunta.objects.filter(
            data_publicacao__lte = timezone.now()
        ).filter(
            data_encerramento__gte = timezone.now()
        ).order_by('-data_publicacao')
        rotulos = Rotulo.objects.all()
        contexto = {'enquetes': enquetes, 'rotulos': rotulos}
        return render(request, 'enquetes/index.html', contexto)

class BuscaView(generic.View):
    def get(self, request, *args, **kwargs):
        str_busca = request.GET['str_busca']
        enquetes = Pergunta.objects.filter(
            data_publicacao__lte = timezone.now()
        ).filter(
            data_encerramento__gt = timezone.now()
        ).order_by('-data_publicacao')
        if str_busca:
            enquetes = enquetes.filter(texto__icontains = str_busca)
        contexto = {'enquetes': enquetes,}
        return render(request, 'enquetes/busca.html', contexto)

class EncerradasView(generic.View):
    def get(self, request, *args, **kwargs):
        enquetes = Pergunta.objects.filter(
            data_encerramento__lte=timezone.now()
        ).order_by('-data_publicacao')
        contexto = {'enquetes': enquetes,}
        return render(request, 'enquetes/encerradas.html', contexto)

class AutorView(generic.View):
    def get(self, request, *args, **kwargs):
        id_autor = kwargs['pk']
        autor = get_object_or_404(Autor, pk=id_autor)
        enqs = Pergunta.objects.filter(autor=autor).order_by('-data_publicacao')
        encerradas = enqs.exclude(data_encerramento__gte = timezone.now())
        ativas = enqs.exclude(data_encerramento__lt = timezone.now())
        contexto = {
            'autor': autor, 'ativas': ativas, 'encerradas': encerradas
        }
        return render(request, 'enquetes/autor.html', contexto)

class RotuloView(generic.View):
    def get(self, request, *args, **kwargs):
        id_rotulo = kwargs['pk']
        rotulo = get_object_or_404(Rotulo, pk=id_rotulo)
        enquetes = rotulo.pergunta_set.all().order_by('-data_publicacao')
        encerradas = enquetes.exclude(data_encerramento__gte = timezone.now())
        ativas = enquetes.exclude(data_encerramento__lt = timezone.now())
        contexto = {
            'rotulo': rotulo, 'ativas': ativas, 'encerradas': encerradas
        }
        return render(request, 'enquetes/rotulo.html', contexto)

class DetalhesView(generic.View):
    def get(self, request, *args, **kwargs):
        id_enquete = kwargs['pk']
        pergunta = get_object_or_404(Pergunta, pk = id_enquete)
        if pergunta.data_publicacao > timezone.now():
            raise Http404
        if pergunta.data_encerramento < timezone.now().date():
            opcoes = pergunta.opcao_set.all().order_by('-votos')
            contexto = {'pergunta': pergunta, 'opcoes': opcoes}
            return render(request, 'enquetes/final.html', contexto)
        return render(request, 'enquetes/enquete.html', {'pergunta': pergunta})

class ResultadoView(generic.View):
    def get(self, request, *args, **kwargs):
        id_enquete = kwargs['pk']
        pergunta = get_object_or_404(Pergunta, pk = id_enquete)
        return render(request, 'enquetes/resultado.html', {'pergunta':pergunta})

class VotacaoView(generic.View):
    def post(self, request, *args, **kwargs):
        id_enquete = kwargs['pk']
        pergunta = get_object_or_404(Pergunta, pk = id_enquete)
        try:
            op_votada = pergunta.opcao_set.get(pk = request.POST['opcao'])
        except (KeyError, Opcao.DoesNotExist):
            messages.error(request, 'Uma opção precisa ser selecionada!')
            return render(
                request, 'enquetes/enquete.html', {'pergunta': pergunta}
            )
        op_votada.votos += 1
        op_votada.save()
        messages.success(request, 'Voto registrado com sucesso.')
        return HttpResponseRedirect(
            reverse('enquetes:resultado', args=(pergunta.id,))
        )

class NovoAutorView(generic.View):
    def get(self, request, *args, **kwargs):
        return render(request, 'enquetes/novo_autor.html')
    def post(self, request, *args, **kwargs):
        # recuperar parâmetros do form
        nome = request.POST['nome']
        sobrenome = request.POST['sobrenome']
        email = request.POST['email']
        genero = request.POST['genero']
        descricao = request.POST['descricao']
        username = request.POST['login']
        senha1 = request.POST['senha1']
        senha2 = request.POST['senha2']

        # validar, instanciar objetos e cadastrar no banco de dados
        if (nome and sobrenome and email and genero and descricao and
            username and senha1 and senha2):
            if senha1 == senha2:
                if not User.objects.filter(username=username).exists():
                    if not User.objects.filter(email=email).exists():
                        user = User.objects.create_user(username, email, senha1)
                        user.first_name = nome
                        user.last_name = sobrenome
                        user.save()
                        Autor.objects.create(
                            nome = nome, genero = genero,
                            descricao = descricao, usuario = user
                        )
                        messages.success(
                            request, 'Usuário cadastrado com sucesso!'
                        )
                    else:
                        messages.error(
                            request, 'O e-mail informado já existe na base!'
                        )
                        return render(request, 'enquetes/novo_autor.html')
                else:
                    messages.warning(
                        request, 'O login informado já existe na base!'
                    )
                    return render(request, 'enquetes/novo_autor.html')
            else:
                messages.warning(
                    request, 'As senhas informadas precisam ser iguais!'
                )
                return render(request, 'enquetes/novo_autor.html')
        else:
            messages.warning(
                request, 'Todos os parâmetros precisam ser informados!'
            )
            return render(request, 'enquetes/novo_autor.html')
        # Faz o login do usuário e leva à Página Principal
        login(request, user)
        messages.success(request,'Usuário logado com sucesso!')
        return HttpResponseRedirect(reverse('enquetes:index', args=()))

@method_decorator(login_required, name='dispatch')
class PerfilView(generic.View):
    def get(self, request, *args, **kwargs):
        if not request.user.autor:
            messages.warning(request, 'Usuário logado precisa ser um Autor')
            return render(request, 'enquetes/novo_autor.html')
        return render(request, 'enquetes/editar_perfil.html')
    def post(self, request, *args, **kwargs):
        # recuperar parâmetros do form
        nome = request.POST['nome']
        sobrenome = request.POST['sobrenome']
        email = request.POST['email']
        genero = request.POST['genero']
        descricao = request.POST['descricao']
        senha1 = request.POST['senha1']
        senha2 = request.POST['senha2']

        # validar, atualizar e salvar no banco de dados
        if nome and sobrenome and email:
            if request.user.first_name != nome:
                request.user.first_name = nome
            if request.user.last_name != sobrenome:
                request.user.last_name = sobrenome
            if request.user.email != email:
                if User.objects.filter(email=email).exists():
                    messages.warning(
                        request, 'O e-mail informado deve ser único no sistema!'
                    )
                    return render(request, 'enquetes/editar_perfil.html')
                request.user.email = email
        if senha1 and senha2:
            if not senha1 == senha2:
                messages.warning(
                    request, 'As senhas informadas precisam ser iguais!'
                )
                return render(request, 'enquetes/editar_perfil.html')
            request.user.set_password(senha1)
        request.user.save()
        if nome and genero and descricao:
            if request.user.autor.nome != nome:
                request.user.autor.nome = nome
            if request.user.autor.genero != genero:
                request.user.autor.genero = genero
            if request.user.autor.descricao != descricao:
                request.user.autor.descricao = descricao
            request.user.autor.save()
        messages.success(request, 'Perfil atualizado com sucesso.')
        return HttpResponseRedirect(
            reverse('enquetes:autor', args=(request.user.autor.id,))
        )

@method_decorator(login_required, name='dispatch')
class NovaEnqueteView(generic.View):
    def get(self, request, *args, **kwargs):
        form = PerguntaForm()
        opcoes = OpcaoFormset()
        contexto = {'form': form, 'opcoes': opcoes}
        return render(request,'enquetes/nova_enquete.html', contexto)
    def post(self, request, *args, **kwargs):
        form = PerguntaForm(request.POST, request.FILES)
        if form.is_valid():
            pergunta = form.save(commit=False)
            pergunta.data_publicacao = timezone.now()
            pergunta.autor = request.user.autor

mysite/enquetes/templates/enquetes/autor.html
{% extends 'enquetes/base.html' %}
{% load static %}

{% block titulo %}
    <h3>Perfil de Autor: {{ autor.nome }}
    {% if autor.id == user.autor.id %}
        (<a href="{% url 'enquetes:editar_perfil' user.autor.id %}">edite o seu perfil</a>)
    {% endif %}</h3>
{% endblock %}

{% block conteudo %}
        <b>Gênero:</b> {{ autor.genero }}</br>
        <b>Descrição:</b> {{ autor.descricao }}
        <h4>Enquetes Ativas deste Autor</h4>
        <ul>
        {% for enquete in ativas.all %}
            <li>
               <a href="{% url 'enquetes:detalhes' enquete.id %}">
                   {{ enquete.texto }}
                </a>
            </li>
        {% endfor %}
        {% if not ativas %}<li>Nenhuma enquete ativa.</li>{% endif %}
        </ul>
        <hr/>
        <h4>Enquetes Encerradas deste Autor</h4>
        <ul>
        {% for enquete in encerradas.all %}
            <li>
               <a href="{% url 'enquetes:detalhes' enquete.id %}">
                   {{ enquete.texto }}
                </a>
            </li>
        {% endfor %}
        {% if not encerradas %}<li>Nenhuma enquete encerrada.</li>{% endif %}
        </ul>
{% endblock %}

mysite/enquetes/templates/enquetes/base.html
{% load static %}

<html>
    <head>
        <title>App Enquetes</title>
        <link rel="stylesheet" type="text/css"
              href="{% static 'enquetes/css/style.css' %}"/>
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
    </head>
    <body>
        {% block titulo_principal %}
        <h1>Aplicação Enquetes - DSWeb 2021.2</h1>
        {% endblock %}

        {% block titulo %}{% endblock %}

        {% block mensagem_de_erro %}
        {% if messages %}
            {% for msg in messages %}
                <div class="alert alert-{% if msg.level_tag == 'error' %}danger{% else %}{{ msg.level_tag }}{% endif %}" role="alert">
                    {{ msg.message }}
                </div>
            {% endfor %}
        {% endif %}
        {% endblock %}

        {% block conteudo %}
        {% endblock %}

        {% block menu %}
        <hr/>
        <a href="{% url 'enquetes:index' %}">Principal</a> |
        <a href="{% url 'enquetes:encerradas' %}">Resultados</a> |
        <a href="{% url 'enquetes:nova_enquete' %}">(+) Nova enquete</a> |
        <a href="{% url 'admin:index' %}">Administração</a>
        {% if user.is_authenticated %}
            | Usuário: <a href="{% url 'enquetes:autor' user.autor.id %}">
            {{ user.username }}</a>
            | <a href="{% url 'logout' %}?next={% url 'enquetes:index' %}">Logout</a>
        {% else %}
            | <a href="{% url 'login' %}?next={% url 'enquetes:index' %}">Login</a>
        {% endif %}
        {% block itens_de_menu %}{% endblock %}
        {% endblock %}
        <br />&copy; Copyrigth DSWeb 2021.2.
    </body>
</html>

mysite/enquetes/templates/enquetes/busca.html
{% extends 'enquetes/base.html' %}
{% load static %}

{%block titulo %}<h3>Resultado da Busca</h3>{% endblock %}

{% block conteudo %}
    {% if enquetes %}
        <ul>
            {% for pergunta in enquetes %}
                <li><a href="{% url 'enquetes:detalhes' pergunta.id %}">
                    {{ pergunta.texto | truncatewords:13 }}</a>
                </li>
            {% endfor %}
        </ul>
    {% else %}
        <h3>Nenhuma enquete contendo o termo buscado</h3>
    {% endif %}
{% endblock %}

mysite/enquetes/templates/enquetes/editar_perfil.html
{% extends 'enquetes/base.html'%}
{% load static %}

{% block titulo %}
    <h3>Edição de Perfil do Usuário "{{ user.username }}"</h3>
{% endblock %}

{% block conteudo %}
        <form method="post" action="{% url 'enquetes:editar_perfil' user.autor.id %}">
            {% csrf_token %}
            Nome: <input type="text" name="nome" size="30"
                value="{{ user.first_name }}"><br/>
            Sobrenome: <input type="text" name="sobrenome" size="30"
                value="{{ user.last_name }}"><br/>
            E-mail: <input type="email" name="email"
                value="{{ user.email }}"><br/>
            Gênero: <input type="text" name="genero" size="43"
                value="{{ user.autor.genero }}"><br/>
            Descrição:<br/>
            <textarea name="descricao" cols="50">{{ user.autor.descricao }}</textarea>
            <br/>
            <fieldset>
                <legend>Alterar senha para o usuário {{ user.username }}: </legend>
                <b>Obs.: a alteração da senha causa o logout do usuário.</b><br/>
                Informe a Senha: <input type="password" name="senha1"><br/>
                Repita a Senha: <input type="password" name="senha2"><br/>
            </fieldset>

            <input type="submit" value="Atualizar Cadastro">
        </form>
{% endblock %}

mysite/enquetes/templates/enquetes/encerradas.html
{% extends 'enquetes/base.html' %}
{% load static %}

{%block titulo %}<h3>Enquetes Encerradas</h3>{% endblock %}

{% block conteudo %}
        {% if enquetes %}
            <ul>
                {% for pergunta in enquetes %}
                    <li><a href="{% url 'enquetes:detalhes' pergunta.id %}">
                        {{ pergunta.texto | truncatewords:13 }}</a>
                        (encerrou em
                        {{ pergunta.data_encerramento | date:"d/M/Y" }})
                    </li>
                {% endfor %}
            </ul>
        {% else %}
            <h3>Nenhuma enquete encerrada até essa data!</h3>
        {% endif %}
{% endblock %}

mysite/enquetes/templates/enquetes/enquete.html
{% extends 'enquetes/base.html' %}
{% load static %}

{% block titulo %}<h3>Detalhes da Enquete #{{ pergunta.id }}</h3>{% endblock %}

{% block conteudo %}
    <h4>Enquete: {{ pergunta.texto | title }}</h4>
    {% if pergunta.imagem %}
        <center>
        <img src="{{ pergunta.imagem.url }}" alt="Logo da enquete" height="180">
        </center>
        <br/>
    {% endif %}
    <b>Escolha a opção desejada:</b><br/>
    <form method="post" action="{% url 'enquetes:votacao' pergunta.id %}">
        {% csrf_token %}
        <ul>
            {% for opcao in pergunta.opcao_set.all %}
                <li>
                    <input type="radio" name="opcao" value="{{ opcao.id }}"
                           id="opcao{{ forloop.counter }}">
                    <label for="opcao{{ forloop.counter }}">
                        {{ opcao.texto }}
                    </label>
                </li>
            {% endfor %}
        </ul>
        <input type="submit" value="Registe o seu voto">
    </form>
    <hr/>
    <h4>Detalhes da Enquete:</h4>
    <b>Autor:</b>
    <a href="{% url 'enquetes:autor' pergunta.autor.id %}">
        {{ pergunta.autor.nome }}
    </a><br/>
    <b>Rótulos:</b>
    {% for rotulo in pergunta.rotulos.all %}
        <a href="{% url 'enquetes:rotulo' rotulo.id %}">
        {{ rotulo.titulo }}</a>{% if forloop.counter < pergunta.rotulos.count %};
        {% endif %}
    {% endfor %}<br/>
    <b>Data de publicação:</b>
    {{ pergunta.data_publicacao | date:"d/m/Y"}}<br/>
    <b>Encerra em: </b>
    {{ pergunta.data_encerramento | timeuntil }}<br/>
{% endblock %}

mysite/enquetes/templates/enquetes/final.html
{% extends 'enquetes/base.html' %}
{% load static %}

{% block titulo %}
<h3>Resultado FINAL da Enquete #{{ pergunta.id }}</h3>
{% endblock %}

{% block conteudo %}
    <h4>Enquete: {{ pergunta.texto }}</h4>
    <ul>
        {% for opcao in opcoes %}
            <li>
            {% if forloop.counter == 1 %}<b>[vencedora]{% endif %}
            {{ opcao.texto }} == {{ opcao.votos }}
            voto{{ opcao.votos | pluralize }}
            == {{ opcao.porcentagem | floatformat:"0" }}%
            {% if forloop.counter == 1 %}</b><p></p>{% endif %}
            </li>
        {% endfor %}
    </ul>
    <hr/>
    <h4>Detalhes da Enquete:</h4>
    <b>Autor:</b>
    <a href="{% url 'enquetes:autor' pergunta.autor.id %}">
        {{ pergunta.autor.nome }}
    </a><br/>
    <b>Rótulos:</b>
    {% for rotulo in pergunta.rotulos.all %}
        <a href="{% url 'enquetes:rotulo' rotulo.id %}">
        {{ rotulo.titulo }}</a>{% if forloop.counter < pergunta.rotulos.count %};
        {% endif %}
    {% endfor %}<br/>
    <b>Data de publicação:</b>
    {{ pergunta.data_publicacao | date:"d/m/Y"}}<br/>
    <b>Data de encerramento:</b>
    {{ pergunta.data_encerramento | date:"d/m/Y"}}<br/>
{% endblock %}

mysite/enquetes/templates/enquetes/index.html
{% extends 'enquetes/base.html' %}
{% load static %}

{%block titulo %}{% endblock %}

{% block conteudo %}
    <hr/>
    <b>Pesquise enquetes por rótulo: </b>
    {% for r in rotulos %}
        <a href="{% url 'enquetes:rotulo' r.id %}">{{ r.titulo }}</a>{% if forloop.counter < rotulos.count %};
        {% endif %}
    {% endfor %}
    <hr/>
    <form method="get" action="{% url 'enquetes:busca' %}">
        <b>Pesquise enquetes pelo texto:</b>
        <input type="text" size="40" name="str_busca"/>
        <input type="submit" value="Pesquisar">
    </form>
    <hr/>

    <center>
        <img src="{% static 'enquetes/img/enquetes-banner.jpg' %}" width="300" />
    </center>
    {% if enquetes %}
        <ul>
            {% for pergunta in enquetes %}
                <li><a href="{% url 'enquetes:detalhes' pergunta.id %}">
                    {{ pergunta.texto | truncatewords:13 }}</a>
                </li>
            {% endfor %}
        </ul>
    {% else %}
        <h3>Nenhuma enquete cadastrada até o momento!</h3>
    {% endif %}
{% endblock %}

mysite/enquetes/templates/enquetes/nova_enquete.html
{% extends 'enquetes/base.html'%}
{% load static %}

{% block titulo %}<h3>Cadastramento de Enquete</h3>{% endblock %}

{% block conteudo %}
        <form method="post" enctype="multipart/form-data"
              action="{% url 'enquetes:nova_enquete' %}">
            {% csrf_token %}
            <table>
            {{ form.as_table }}
            <tr></tr><th colspan="2">&nbsp;</th></tr>
            <tr><th colspan="2"><u>Lista de Opções</u>:</th></tr>
            {{ opcoes.management_form }}
            {{ opcoes.as_table }}
            </table>
            <input type="submit" value="Cadastrar Enquete">
        </form>
{% endblock %}

mysite/enquetes/templates/enquetes/nova_enquete_antigo.html
{% extends 'enquetes/base.html'%}
{% load static %}

{% block titulo %}<h3>Cadastramento de Enquete</h3>{% endblock %}

{% block conteudo %}
        <form method="post" action="{% url 'enquetes:nova_enquete' %}">
            {% csrf_token %}
            <p>Enunciado da enquete:
            <input type="text" name="texto" size="70">*</p>
            <b>Alternativas (as duas primeiras são obrigatórias):</b><br/>
            (1) <input type="text" name="op1" size="45">*<br/>
            (2) <input type="text" name="op2" size="45">*<br/>
            (3) <input type="text" name="op3" size="45"><br/>
            (4) <input type="text" name="op4" size="45"><br/>
            (5) <input type="text" name="op5" size="45"><br/>
            (6) <input type="text" name="op6" size="45"><br/>
            Data de encerramento:
            <input type="date" name="encerramento">*<br/>
            {% if rotulos %}
                Selecione os rótulos correspondentes:
                <ul>
                    {% for r in rotulos %}
                        <input type="checkbox" id="r{{ forloop.counter }}"
                               name="rotulos" value="{{ r.id }}"/>
                        <label for="r{{ forloop.counter }}">{{ r.titulo }}
                        </label>
                        <br/>
                    {% endfor %}
                </ul>
            {% endif %}
            <input type="submit" value="Cadastrar Enquete">
        </form>
        <p><b>Obs.:</b> "*" campos obirgatórios.</p>
{% endblock %}

mysite/enquetes/templates/enquetes/resultado.html
{% extends 'enquetes/base.html' %}
{% load static %}

{% block titulo %}
<h3>Resultado Parcial da Enquete #{{ pergunta.id }}</h3>
{% endblock %}

{% block conteudo %}
    <h4>Enquete: {{ pergunta.texto }}</h4>
    <ul>
        {% for opcao in pergunta.opcao_set.all %}
            <li>{{ opcao.texto }} == {{ opcao.votos }}
                voto{{ opcao.votos | pluralize }}
            </li>
        {% endfor %}
    </ul>
    <hr/>
    <h4>Detalhes da Enquete:</h4>
    <b>Autor:</b>
    <a href="{% url 'enquetes:autor' pergunta.autor.id %}">
        {{ pergunta.autor.nome }}
    </a><br/>
    <b>Rótulos:</b>
    {% for rotulo in pergunta.rotulos.all %}
        <a href="{% url 'enquetes:rotulo' rotulo.id %}">
        {{ rotulo.titulo }}</a>{% if forloop.counter < pergunta.rotulos.count %};
        {% endif %}
    {% endfor %}<br/>
    <b>Data de publicação:</b>
    {{ pergunta.data_publicacao | date:"d/m/Y"}}<br/>
    <b>Data de encerramento:</b>
    {{ pergunta.data_encerramento | date:"d/m/Y"}}<br/>
{% endblock %}

{% block menu %}
        {{ block.super }}
        | <a href="{% url 'enquetes:detalhes' pergunta.id %}">Votar novamente?</a>
{% endblock %}